
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     
C     UTILITY FUNCTION
C     - CopyVectorR8() - Copy vector vx to vy  (Real*8)
C     
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE CopyVectorR8(x_1,x_2,vx,y_1,y_2,vy)
      INTEGER x_1,x_2,y_1,y_2
      REAL*8  vx(*),vy(*)

      INTEGER ix,iy
 
      IF (y_2-y_1.NE.x_2-x_1) THEN
        WRITE(6,*) '!!! ATTENTION, ERROR COPY VECTOR !!!'
        STOP
      ENDIF
  
      ix = x_1
      DO iy = y_1,y_2
        vy(iy) = vx(ix)
        ix     = ix + 1
      ENDDO

      RETURN
      END ! CopyVectorR8
C     
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      SUBROUTINE CopyVectorC16(x_1,x_2,vx,y_1,y_2,vy)
      INTEGER x_1,x_2,y_1,y_2
      COMPLEX*16  vx(*),vy(*)

      INTEGER ix,iy
 
      IF (y_2-y_1.NE.x_2-x_1) THEN
        WRITE(6,*) '!!! ATTENTION, ERROR COPY VECTOR !!!'
        STOP
      ENDIF
  
      ix = x_1
      DO iy = y_1,y_2
        vy(iy) = vx(ix)
        ix     = ix + 1
      ENDDO

      RETURN
      END ! CopyVectorC16
C                                                                    C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                    C
   
      SUBROUTINE CopyMatrixR8(x00,x01,x10,x11,nx1,nx2,mx,
     >                        y00,y01,y10,y11,ny1,ny2,my)
      INTEGER x00,x01,x10,x11,y00,y01,y10,y11,nx1,nx2,ny1,ny2
      REAL*8  mx(nx1,nx2),my(ny1,ny2)

      INTEGER ix1,ix2,iy1,iy2

      IF ((y01-y00.NE.x01-x00).or.(y11-y10.NE.x11-x10)) THEN
        WRITE(6,*) '!!! ATTENTION, ERROR COPY MATRIX !!!'
        STOP
      ENDIF

      ix1 = x00
      DO iy1 = y00,y01
        ix2 = x10
        DO iy2 = y10,y11
          my(iy1,iy2) = mx(ix1,ix2)
          ix2 = ix2 + 1
        ENDDO
        ix1 = ix1 + 1
      ENDDO

      RETURN
      END ! CopyMatrixR8
C                                                                    C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                    C

      SUBROUTINE CopyMatrixI4(x00,x01,x10,x11,nx1,nx2,mx,
     >                        y00,y01,y10,y11,ny1,ny2,my)
      INTEGER x00,x01,x10,x11,y00,y01,y10,y11,nx1,nx2,ny1,ny2
      INTEGER  mx(nx1,nx2),my(ny1,ny2)

      INTEGER ix1,ix2,iy1,iy2

      IF ((y01-y00.NE.x01-x00).or.(y11-y10.NE.x11-x10)) THEN
        WRITE(6,*) '!!! ATTENTION, ERROR COPY MATRIX !!!'
        STOP
      ENDIF

      ix1 = x00
      DO iy1 = y00,y01
        ix2 = x10
        DO iy2 = y10,y11
          my(iy1,iy2) = mx(ix1,ix2)
          ix2 = ix2 + 1
        ENDDO
        ix1 = ix1 + 1
      ENDDO

      RETURN
      END ! CopyMatrixI4
C                                                                    C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                    C

      SUBROUTINE TransMatrixToVectorR8(mx,np1,np2,s1,s2,e1,e2,vx,sa,ea)
      INTEGER np1,np2,s1,s2,e1,e2,sa,ea
      REAL*8  mx(np1,np2),vx(*)

      INTEGER i_1,i_2,ia

      IF ((e2-s2+1)*(e1-s1+1).NE.(ea-sa+1)) THEN
        WRITE(6,*) '!!! ATTENTION, ERROR COPY MATRIX !!!'
        STOP
      ENDIF
  
      ia = sa
      DO i_1 = s1,e1
        DO i_2 = s2,e2
          vx(ia) = mx(i_1,i_2)
          ia = ia + 1
        ENDDO 
      ENDDO

      END ! 
C                                                                    C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                    C
 
      SUBROUTINE ConstantMatrixI4(mx,np1,np2,n1,n2,const_val)
      INTEGER np1,np2,n1,n2
      INTEGER mx(np1,np2),const_val

      INTEGER i_1,i_2
      
      DO i_1 = 1,n1
        DO i_2 = 1,n2
          mx(i_1,i_2) = const_val
        ENDDO
      ENDDO

      RETURN
      END ! ConstantMatrixI4

C                                                                    C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                    C
      SUBROUTINE ConstantMatrixR8(mx,np1,np2,n1,n2,const_val)
      INTEGER np1,np2,n1,n2
      REAL*8  mx(np1,np2),const_val

      INTEGER i_1,i_2
      
      DO i_1 = 1,n1
        DO i_2 = 1,n2
          mx(i_1,i_2) = const_val
        ENDDO
      ENDDO

      RETURN
      END ! ConstantMatrixR8

C                                                                    C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                    C

      SUBROUTINE ConstantMatrixC16(mx,np1,np2,n1,n2,const_val)
      INTEGER np1,np2,n1,n2
      REAL*8  const_val
      COMPLEX*16 mx(np1,np2)

      INTEGER i_1,i_2
      
      DO i_1 = 1,n1
        DO i_2 = 1,n2
          mx(i_1,i_2) = const_val
        ENDDO
      ENDDO

      RETURN
      END ! ConstantMatrixC16

C                                                                    C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                    C

      SUBROUTINE ConstantVectorI4(ix,n,const_ival)
      INTEGER n,ix(*),const_ival

      INTEGER i
      
      DO i = 1,n
        ix(i) = const_ival
      ENDDO

      RETURN
      END ! ConstantVectorI4

C                                                                    C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                    C

      SUBROUTINE ConstantVectorR8(vx,n,const_val)
      INTEGER n
      REAL*8  vx(*),const_val

      INTEGER i
      
      DO i = 1,n
        vx(i) = const_val
      ENDDO

      RETURN
      END ! ConstantVectorR8

C                                                                    C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                    C
      SUBROUTINE ConstantVectorC16(vx,n,const_val)
      INTEGER n
      REAL*8  const_val
      COMPLEX*16  vx(*)

      INTEGER i
      
      DO i = 1,n
        vx(i) = const_val
      ENDDO

      RETURN
      END ! ConstantVectorC16


C                                                                    C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                    C
 
      SUBROUTINE CumulativeDistance(nx,dx,xdis)
      INCLUDE 'constant.h'
      REAL*8  dx(*),xdis(*)
      INTEGER nx,ix
      
      xdis(1) = D0
      DO  ix = 2,nx+1
       xdis(ix) = xdis(ix-1) + dx(ix-1)
      ENDDO 

      RETURN
      END ! CumulativeDistance

C                                                                    C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                    C

      SUBROUTINE DistanceBetweenBlocks(nx,dx,cx)
      INCLUDE 'constant.h'
      REAL*8  dx(*),cx(*)
      INTEGER nx,ix
      
      DO  ix = 2,nx
       cx(ix) = dx(ix) + dx(ix-1)
      ENDDO 
      cx(1)    = D2*dx(1)
      cx(nx+1) = D2*dx(nx)

      RETURN
      END ! CumulativeDistance

C                                                                    C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                    C

      INTEGER FUNCTION SumIndx(Indx,np1,np2,np3,np4,
     >                         s1,s2,s3,s4,e1,e2,e3,e4)
      INTEGER Indx(np1,np2,np3,np4),np1,np2,np3,np4
      INTEGER s1,s2,s3,s4,e1,e2,e3,e4

      INTEGER sumx,i_1,i_2,i_3,i_4
       
      sumx = 0
      SumIndx = 0
      DO i_1 = s1,e1
        DO i_2 = s2,e2
          DO i_3 = s3,e3
            DO i_4 = s4,e4
              sumx = sumx + Indx(i_1,i_2,i_3,i_4)
            ENDDO ! i_4
          ENDDO ! i_3
        ENDDO ! i_2
      ENDDO ! i_1
      SumIndx = sumx
     
      RETURN
      END ! SumIndx

C                                                                    C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                    C

      INTEGER FUNCTION IndexData(Indx,np1,np2,np3,np4,
     >                           iml,irl,ipl,isl,NRes,NPer,NSta)
      INTEGER iml,irl,ipl,isl,np1,np2,np3,np4,NRes(*),NPer(*),NSta(*)
      INTEGER Indx(np1,np2,np3,np4)

      INTEGER idd,im
      INTEGER SumIndx

      idd = 0
      DO im = 1,iml-1
        idd = idd + SumIndx(Indx,np1,np2,np3,np4,
     >                      im,1,1,1,im,NRes(im),NPer(im),NSta(im))
      ENDDO
      idd = idd + SumIndx(Indx,np1,np2,np3,np4,
     >                    iml,1,1,1,iml,irl-1,NPer(iml),NSta(iml))
      idd = idd + SumIndx(Indx,np1,np2,np3,np4,
     >                    iml,irl,1,1,iml,irl,ipl-1,NSta(iml))
      idd = idd + SumIndx(Indx,np1,np2,np3,np4,
     >                    iml,irl,ipl,1,iml,irl,ipl,isl)
      IndexData = idd

      RETURN
      END  ! IndexData()

C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C

      INTEGER FUNCTION SumMatrix_I4(mx,np1,np2,s1,s2,e1,e2)
      INTEGER mx(np1,np2),np1,np2,s1,s2,e1,e2

      INTEGER sumx,i_1,i_2

      IF ((s1.LE.0).OR.(s2.LE.0).OR.(e1.LE.0).OR.(e2.LE.0)) THEN
        SumMatrix_I4 = 0
        GOTO 500
      ENDIF

      sumx = 0
      DO i_1 = s1,e1
        DO i_2 = s2,e2
          sumx = sumx + mx(i_1,i_2)
        ENDDO ! i_2
      ENDDO ! i_1
      SumMatrix_I4 = sumx

500   CONTINUE

      RETURN
      END ! SumMatrix_I4

C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C

      REAL*8 FUNCTION SumVector_R8(n,a)
      INCLUDE 'constant.h'
      INTEGER n
      REAL*8 a(*)

      INTEGER i
      REAL*8  sumx

      sumx = D0
      DO i = 1,n
        sumx = sumx + a(i)
      ENDDO 
      SumVector_R8 = sumx

      RETURN
      END ! SumVector_R8
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     Find length of the string
 
      SUBROUTINE Lenb(string,length)
      CHARACTER*(*) string
      INTEGER nstr,istr,length
 
      nstr = len(string)
      DO istr=nstr,1,-1
         IF (string(istr:istr).ne.' ') THEN
            length = istr
            RETURN
         ENDIF
      ENDDO
      length = 0

      RETURN
      END !Subroutine lenb()

C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     Initialize string
 
      SUBROUTINE IniStr(string)
      CHARACTER*(*) string
      INTEGER nstr,istr
 
      nstr = len(string)
      DO istr=1,nstr
        string(istr:istr) = ' '
      ENDDO

      RETURN
      END !Subroutine IniStr

C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     Search nearest period (same station)

      SUBROUTINE SearchPeriod(DatInx,SenInx,np1,np2,np3,np4,
     >                        iml,irl,ipl,isl,npp,ipb,ipa)
      INTEGER iml,irl,ipl,isl,np1,np2,np3,np4,ipb,ipa,npp
      INTEGER DatInx(np1,np2,np3,np4),SenInx(np1,np2,np3,np4)
     
      INTEGER ip
   
      ipb = 0
      ipa = 0

      DO ip = ipl-1,1,-1
        IF ((SenInx(iml,irl,ip,isl).EQ.1).AND.
     >      (DatInx(iml,irl,ip,isl).EQ.1)) THEN
           ipb = ip
           GOTO 50
        ENDIF
      ENDDO
50    CONTINUE

      DO ip = ipl+1,npp
        IF ((SenInx(iml,irl,ip,isl).EQ.1).AND.
     >      (DatInx(iml,irl,ip,isl).EQ.1)) THEN
           ipa = ip
           GOTO 100
        ENDIF
      ENDDO
100   CONTINUE
 
      RETURN
      END  ! SearchPeriod()

C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     Search nearest station (same period)

      SUBROUTINE SearchStation(DatInx,SenInx,np1,np2,np3,np4,
     >                         iml,irl,ipl,isl,nss,isb,isa)
      INTEGER iml,irl,ipl,isl,np1,np2,np3,np4,isb,isa,nss
      INTEGER DatInx(np1,np2,np3,np4),SenInx(np1,np2,np3,np4)
     
      INTEGER is

      isb = 0
      isa = 0
   
      DO is = isl-1,1,-1
        IF ((SenInx(iml,irl,ipl,is).EQ.1).AND.
     >      (DatInx(iml,irl,ipl,is).EQ.1)) THEN
           isb = is
           GOTO 50
        ENDIF
      ENDDO
50    CONTINUE

      DO is = isl+1,nss
        IF ((SenInx(iml,irl,ipl,is).EQ.1).AND.
     >      (DatInx(iml,irl,ipl,is).EQ.1)) THEN
           isa = is
           GOTO 100
        ENDIF
      ENDDO
100   CONTINUE

      RETURN
      END  ! SearchStation()

C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C

      integer function findstr(str1,str2)
      character*(*) str1, str2
c     returns the position of str2 in str1.  Ignores case.
c     returns 0 if str2 not found in str1

      integer i, j, capdif
      logical same

      capdif= ichar('a')-ichar('A')

      do 20 i= 1, len(str1)-len(str2)+1
         do 10 j=1,len(str2)

            same= str1(i+j-1:i+j-1) .eq. str2(j:j)        .or.
    
     &       'A'.le.str2(j:j) .and. str2(j:j).le.'Z' .and.
     &       ichar(str1(i+j-1:i+j-1)) .eq. ichar(str2(j:j))+capdif .or.
 
     &       'a'.le.str2(j:j) .and. str2(j:j).le.'z' .and.
     &       ichar(str1(i+j-1:i+j-1)) .eq. ichar(str2(j:j)) - capdif
 
            if( .not.same ) go to 20
 10      continue
         findstr=i
         return
 20   continue
 
      findstr=0
      return
      end

C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      integer function begwrd(string,iwrd)
      integer iwrd
      character*(*) string
c     Returns the index of the first non-blank character in the iwrd'th
c     non-blank word (word are seperated by spaces, tabs or commas).
c     Returns len if iwrd'th word is not found.
      integer i, nword
      logical wasblk
      intrinsic len

      wasblk=.true.
      nword= 0
      do 100 i=1,len(string)
          if( string(i:i).eq.' ' .or.
     &        string(i:i).eq.',' .or.
     &        string(i:i).eq.'  '    )then

c             /* current character is blank
              wasblk=.true.
          else
              if(wasblk)  nword= nword + 1
              wasblk= .false.
              if(nword.eq.iwrd)then
                  begwrd= i
                  return
              end if
          end if
  100 continue

      begwrd= len(string)
      return
      end

C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      integer function endwrd(string,iwrd)
      integer iwrd
      character*(*) string
c     Returns the index of the last non-blank character in the iwrd'th
c     non-blank word (word are seperated by spaces, tabs or commas).
c     Returns len if iwrd'th word is not found.
      integer i, nword
      logical wasblk
      intrinsic len

      wasblk=.true.
      nword= 0
      do 100 i=1,len(string)
          if( string(i:i).eq.' ' .or.
     &        string(i:i).eq.',' .or.
     &        string(i:i).eq.'  '    )then

c             /* current character is blank
              wasblk=.true.
              if(nword.eq.iwrd) RETURN
          else
              if(wasblk) nword= nword + 1
              wasblk= .false.
              if(nword.eq.iwrd) endwrd= i
          end if
  100 continue

      endwrd= len(string)
      return
      end

C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C

      SUBROUTINE ModelChange(Nzb,Ny,RhoOld,RhoNew,RhoChange,
     >           MNormOld,MNormNew,MNormChange)
      INCLUDE 'parameter.h'
      INCLUDE 'constant.h'

      INTEGER Nzb,Ny
      REAL*8  RhoOld(NZ0MX,NY0MX),RhoNew(NZ0MX,NY0MX),RhoChange
      REAL*8  MNormOld,MNormNew,MNormChange

      INTEGER iz,iy,mm
      REAL*8  rdiff,rdiff2
  
      rdiff  =  D0
      rdiff2 =  D0
      DO iy = 1,Ny
        DO iz = 1,Nzb
          rdiff = DABS(RhoNew(iz,iy)-RhoOld(iz,iy))/RhoOld(iz,iy)
          rdiff2 = rdiff2 + rdiff**D2
        ENDDO ! iz
      ENDDO ! iy

      mm = Nzb*Ny
      RhoChange   = DSQRT(rdiff2/mm)*D100
      MNormChange = ((MNormOld-MNormNew)/MNormOld)*D100
 
      RETURN
      END ! ModelChange
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
